package name.nathanmcrae.numbersstation;

import java.awt.datatransfer.StringSelection;
import java.awt.Toolkit;
import java.awt.datatransfer.Clipboard;
import java.io.IOException;
import java.lang.management.ManagementFactory;
import java.nio.file.Path;
import java.nio.file.Paths;
import java.util.logging.Logger;
import java.util.logging.Level;
import java.util.Properties;
import javafx.fxml.FXML;
import javafx.scene.control.Alert;
import javafx.scene.control.Alert.AlertType;
import javafx.scene.control.Hyperlink;
import javafx.scene.control.TextField;

public class AboutController {
    private static final Logger logger = Logger.getLogger(Main.class.getName());

    @FXML
    private TextField directoryTextField;

    @FXML
    private TextField executableTextField;

    @FXML
    private TextField homepageURLTextField;

    @FXML
    private TextField logPathTextField;

    @FXML
    private TextField versionTextField;

    @FXML
    private void initialize() {
        directoryTextField.setText(Main.getConfigPath().toString());

        String processName = ManagementFactory.getRuntimeMXBean().getName();
        long pid = Long.parseLong(processName.split("@")[0]);
        ProcessHandle currentProcess = ProcessHandle.of(pid).orElseThrow();
        Path executablePath = currentProcess.info().command().map(Paths::get).orElseThrow();
        executableTextField.setText(executablePath.toString());

        Properties properties = new Properties();
        try {
            properties.load(getClass().getClassLoader().getResourceAsStream("git.properties"));
        } catch (IOException e) {
            logger.log(Level.SEVERE, "Failed to load git information", e);
        }
        versionTextField.setText(String.valueOf(properties.get("git.commit.id.full")));

        homepageURLTextField.setText("https://git.nathanmcrae.name/nathanmcrae/numbers-station");

        logPathTextField.setText(Main.getStatePath().resolve("main.log").toString());
    }

    public void handleAppExecutableButtonPress() {

    }

    public void handleConfigDirectoryButtonPress() {

    }

    public void handleLogFilePathButtonPress() {

    }
}
